/*
	Chris' 2nd IIST programe please note some of the code has been
	taken and modifined from Edward angel's "interactive computer
	graphics a top down approch" , the polygon and color cube functions to be percise.
*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <GL/Gl.h>
#include <GL/glut.h>

#define SCREENWIDTH 1024.0
#define SCREENHEIGHT 768.0
#define INCREMENT 20
static GLfloat theta[] = {0.0,0.0,0.0};
static GLint axis = 2;

const mw = SCREENHEIGHT/2;
const my = SCREENWIDTH/2;

GLuint	base;
char mytext[256]="set";
int win1, win2;
int stop =0,xon = 0,yon=0,tea = 0, ne =0,up =1;
GLfloat rotate=0,colour =0,rotate2 =0,teaz=0,teax=0,teay=1,rotIISTx =.3,rotIISTy =0.3,rotIISTz =1;
GLfloat rotatepot=0 ,MoveX=0,MoveY=0,track=0,zoom=50, xpos =0,ypos=0;
GLfloat i1=0,i2=1,s1=2,t1=3;
GLubyte image0[64][64][3];
GLubyte image1[64][64][3];
GLubyte data1024 [1024*1024*3];


GLfloat planes[]= {-1.0, 0.0, 1.0, 0.0};
GLfloat planet[]= {0.0, -1.0,  0.0, 1.0};


	GLfloat vertices[][3] = {{-1.0,-1.0,-1.0},{1.0,-1.0,-1.0},
	{1.0,1.0,-1.0}, {-1.0,1.0,-1.0}, {-1.0,-1.0,1.0}, 
	{1.0,-1.0,1.0}, {1.0,1.0,1.0}, {-1.0,1.0,1.0}};

//	GLfloat colors[][4] = {{0.0,0.0,0.0,0.5},{1.0,0.0,0.0,0.5},
//	{1.0,1.0,0.0,0.5}, {0.0,1.0,0.0,0.5}, {0.0,0.0,1.0,0.5}, 
//	{1.0,0.0,1.0,0.5}, {1.0,1.0,1.0,0.5}, {0.0,1.0,1.0,0.5}};

	GLfloat colors[][4] = {{1.0,1.0,1.0,0.5},{1.0,1.0,1.0,0.5},
	{1.0,1.0,1.0,0.5}, {1.0,1.0,1.0,0.5}, {1.0,1.0,1.0,0.5}, 
	{1.0,1.0,1.0,0.5}, {1.0,1.0,1.0,0.5}, {1.0,1.0,1.0,0.5}};

void polygon(int a, int b, int c , int d)
{

/* draw a polygon via list of vertices */

 	glBegin(GL_POLYGON);
	glColor4fv(colors[a]);
	glTexCoord2f(0.0,0.0); 
	glVertex3fv(vertices[a]);
	glColor4fv(colors[b]);
	glTexCoord2f(0.0,1.0);
	glVertex3fv(vertices[b]);
	glColor4fv(colors[c]);
	glTexCoord2f(1.0,1.0); 
	glVertex3fv(vertices[c]);
	glColor4fv(colors[d]);
	glTexCoord2f(1.0,0.0); 
	glVertex3fv(vertices[d]);
	glEnd();
																										}

void colorcube(void)
{

/* map vertices to faces */

	polygon(0,3,2,1);
	polygon(2,3,7,6);
	polygon(0,4,7,3);
	polygon(1,2,6,5);
	polygon(4,5,6,7);
	polygon(0,1,5,4);
}


//<<<<<<<<<<<<maketeapot>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 
void maketeapot(GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT )
{
/*	//set colour for and materal properties for teapot
	GLfloat mat_ambient[]= {RedA, GreenA, BlueA, 1.0};
	GLfloat mat_diffuse[] = {RedD, GreenD, BlueD, 1.0};
	GLfloat mat_specular[] = {1.0, 0.8, 1.0, 1.0};
	GLfloat mat_shininess[] = {10.0};

	
	// set teapot colours
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);*/
	glRotatef(rotateT ,teax,teay,teaz);
	
	glutSolidTeapot(10);

}
///<<<<<<<<<<<<<<<drawI>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and I out of tea pots
void drawI(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	
	glPushMatrix();	
	glTranslated(x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(25+x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();	//middle done
	glPushMatrix();
	glTranslated(x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //all done
		
}

///<<<<<<<<<<<<<<<drawS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and S out of tea pots
void drawS(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	glPushMatrix();	
	glTranslated(x+5,y-10, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-10, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(x+5,y-40, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-60, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();//middle done
	glPushMatrix();
	glTranslated(x+5,y-90, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-90, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //all done
		
}
///<<<<<<<<<<<<<<<drawT>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and T out of tea pots
void drawT(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	glPushMatrix();	
	glTranslated(x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(25+x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();	//middle done
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
		
}
//makesphere
void makesphere(void)
{
	GLUquadricObj *mySphere;
	mySphere = gluNewQuadric();
	gluQuadricDrawStyle(mySphere,GLU_LINE);

	gluSphere(mySphere,2,12,12);
}


///<<<<<<<<<<<<<<<<<<<<draw char>>>>>>>>>>>>>>>>>>>>>>>>>>
void drawtext(const char *text)
{
	int i =0;
	base = glGenLists(256);

	for( i =0; i<255;i++)
	{
		glNewList(base +i,GL_COMPILE);
		//glutBitmapCharacter(GLUT_BITMAP_9_BY_15, i);
		glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, i);
		glEndList();
	}
	glListBase(base);
	glCallLists((GLint) strlen(text),GL_UNSIGNED_BYTE, text);
	
	
}

///<<<<<<<<<<<<<<drawIIST_teapot>>>>>>>>>>>>>>>>>>
void drawIIST_teapot(void)
{
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(MoveX,MoveY,0);
//	glPushMatrix();		
	glRotatef(rotate2, rotIISTx, rotIISTy, rotIISTz);


	drawI(-155,50,1.0,0.0,0.0,0.6,0.2,0.0,rotatepot); //drawI(-155,0,RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	drawI(-75,50 ,1.0,0.0,0.8,0.6,0.2,0.0,rotatepot);
	drawS(0,50   ,0.0,0.0,1.0,0.0,0.2,0.7,rotatepot);
	drawT(75,50  ,0.6,0.6,0.6,0.2,0.2,0.2, rotatepot);
	rotatepot=rotatepot+2;
//	glPopMatrix();
	glPopMatrix();
}

///<<<<<<<<<<<<<<<drawcubT>>>>>>>>>>>>>>>>>>>>>
void drawCubeT(void)
{
	glPushMatrix();

	glScalef(30,80,30);
	colorcube();
	glTranslatef(0,1.5,0);
	glScalef(2,.5,1);
	colorcube();
	glPopMatrix();
}

///<<<<<<<<<<<<<<<<<drawcubeI>>>>>>>>>>>>>>>>>>>>>>>
void drawCubeI(void)
{
	//make I
	glPushMatrix();

	glScalef(30,60,30);
	colorcube();
	glTranslatef(0,1.5,0);
	glScalef(2,.5,1); 
	colorcube();
	glTranslatef(0,-6,0);  
	colorcube();

	glPopMatrix();
}


///<<<<<<<<<<<<<<<<<drawCubes>>>>>>>>>>>>>>>>>>>>>>>>>
void drawCubeS(void)
{
	glPushMatrix();
	glScalef(60,20,30);
	glRotatef(-90,0,0,1);
	colorcube();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(0,-180,0);
	glScalef(60,20,30);
	glRotatef(-90,0,0,1);
	colorcube();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(0,-90,0);
	glScalef(40,20,30);
	glRotatef(-90,0,0,1);
	colorcube();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(50,-115,0);
	glScalef(10,45,30);
	glRotatef(-90,0,0,1);
	colorcube();
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-50,-65,0);
	glScalef(10,45,30);
	glRotatef(-90,0,0,1);
	colorcube();
	glPopMatrix();
}

void LoadTexture(char* filename, int width, int height)
{

	FILE * file;
	file = fopen(filename,"rb");		// Open as a binary file for reading
	fread(data1024,width*height*3,1,file);		// Get all the file data into memory
	fclose(file);				// Close the file

// Using GL_REPLACE means textures are unaffected by last pen color used
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	
	// Set the filter type for when textures are viewed far away
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);

	// Set the filter type for when textures are viewed close up
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	gluBuild2DMipmaps(GL_TEXTURE_2D,3,width,height,GL_RGB,GL_UNSIGNED_BYTE,data1024);
}

void ownTexture(int num)
{
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 
	switch(num)
        {	
            case 0 :
				glTexImage2D(GL_TEXTURE_2D,0,3,64,64,0,GL_RGB,GL_UNSIGNED_BYTE, image0);
			break;
			case 1:
				glTexImage2D(GL_TEXTURE_2D,0,3,64,64,0,GL_RGB,GL_UNSIGNED_BYTE, image1);
			break;
			default :
			break;
		}
}
//<<<<<<<<<<<<<<<<<<<<<<<<<<selextTexture>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void selectTexture(int texture)
{

	// metal6464.raw	star1024.raw	tablecloth256.raw
	// envwall128.raw	crackle256.raw	blue.raw
	// metal6464.raw	sunset.raw
	switch(texture)
	{
		case 0:
			ownTexture(0);
		break;
		case 1:
			ownTexture(1);
		break;
		case 2:
			LoadTexture("metal6464.raw",64,64);
		break;
		case 3:
			LoadTexture("star1024.raw",1024,1024);
		break;
		case 4:
			LoadTexture("tablecloth256.raw",256,256);
		break;
		case 5:
			LoadTexture("envwall128.raw",128,128);
		break;
		case 6:
			LoadTexture("crackle256.raw",256,256);
		break;
		case 7:
			LoadTexture("blue.raw",64,64);
		break;
		case 8:
			LoadTexture("metal6464.raw",64,64);
		break;
		case 9:
			LoadTexture("sunset.raw",256,256);
		break;
	}
}



//<<<<<<<<<<<<<<<<<<<<<<<<<<myDisplay>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

void myDisplay(void)
{


	glMatrixMode(GL_PROJECTION);
	glEnable(GL_TEXTURE_2D);
	glLoadIdentity();	
	glOrtho(-mw/2,  mw/2, -mw/2, mw/2, -50, 500.0);	
	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();	
	gluLookAt(xpos,ypos,zoom, 0,0,0, 0.0,up,0.0);	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	

//	glutSolidTeapot(50);
//	drawIIST_teapot();
	
	

	if (ne ==1)
			glScalef(3,3,3);
	if(tea == 0)
	{
		glPushMatrix();
		glScalef(.5,.5,.5);
		
		selectTexture(i1);
		glTranslatef(-250,0,0);

		drawCubeI();
		glTranslatef(150,0,0);
		//ownTexture(0);
		selectTexture(i2);
		drawCubeI();
		
		glTranslatef(150,0,0);
		selectTexture(s1);
		glPushMatrix();
		glTranslatef(0,97,0);
		glScalef(1,1.1,1);
		drawCubeS();
		glPopMatrix();

		glTranslatef(150,-42,0); 
		selectTexture(t1);
		drawCubeT();
		glPopMatrix();
	}
	else
	{
		

		selectTexture(i1);
		drawI(-155,50,1.0,0.0,0.0,0.6,0.2,0.0,rotatepot); //drawI(-155,0,RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
		selectTexture(i2);
		drawI(-75,50 ,1.0,0.0,0.8,0.6,0.2,0.0,rotatepot);
		selectTexture(s1);
		drawS(0,50   ,0.0,0.0,1.0,0.0,0.2,0.7,rotatepot);
		selectTexture(t1);
		drawT(75,50  ,0.6,0.6,0.6,0.2,0.2,0.2, rotatepot);
	//	rotatepot=rotatepot+2;
	}

//	drawIIST_teapot();

	
	//load background of earth
//	glPushMatrix();
	glRotatef(rotate2, 0, 0, 1);
	glTranslatef(0,0,-200); //earth1024.raw // blue.raw //earth1.raw //starearth.raw
	LoadTexture("earth1024.raw", 1024, 1024);
	glScalef(300,400,1);
	polygon(0,3,2,1);
//	glPopMatrix();


//	glDisable(GL_TEXTURE_2D);
	LoadTexture("whitebright16.raw", 16, 16);

	
	//make some stars
	glPushMatrix();
	glScalef(.005,.005,1);
	glTranslatef(10,50,400);
	glutSolidSphere(1,50,50);
	glTranslatef(10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(10,-10,0);
	glutSolidSphere(1,50,50);
	glTranslatef(0,-10,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,-10,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glPopMatrix();

	glPushMatrix();
	glScalef(.005,.005,1);
	glTranslatef(0,0,400);
	glTranslatef(-10,-10,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(+20,-20,0);
	glutSolidSphere(1,50,50);
	glTranslatef(0,-20,0);
	glutSolidSphere(1,50,50);
	glTranslatef(0,-20,0);
	glutSolidSphere(1,50,50);;
	glTranslatef(+20,0,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,-10,0);
	glutSolidSphere(1,50,50);
	glTranslatef(-10,0,0);
	glutSolidSphere(1,50,50);
	glPopMatrix();

	glPushMatrix();
//	glRotatef(rotate2, 0, 0, 1);
	glTranslatef(-0.2,0.3,410);
	LoadTexture("moon256.raw", 256, 256);
	glScalef(.1,.1,1);
	polygon(0,3,2,1);
	glPopMatrix();

	LoadTexture("whitebright16.raw", 16, 16);
	glPushMatrix();
	glLoadIdentity();
	glColor3f(1.0,1.0,1.0);
	glTranslatef(-mw/2+5,-mw/2 +15,10); //move text
	glScalef(0.04,0.04,1); //set text scale size
	sprintf(mytext,"camera x : %3.1f   camera y : %3.1f     camera z : %3.0f",xpos,ypos,zoom);
	drawtext(mytext);
	glPopMatrix();
	
	glPushMatrix();
	glLoadIdentity();
	glColor3f(1.0,1.0,1.0);
	glTranslatef(-mw/2+5,-mw/2 +5,10);
	glScalef(0.04,0.04,1); //set text scale size
	sprintf(mytext,"rotate teaz : %3.1f  rotate teax : %3.1f  rotate teay : %3.1f",teaz,teax,teay);
	drawtext(mytext);
	glPopMatrix();


	glutPostRedisplay();//updated
	glutSwapBuffers();
}

void Idle(void)
{

// Idle callback
	rotate2 = (stop==0)?rotate2+1:rotate2;
	rotatepot=rotatepot+2;

	if (  zoom>0 && xon) 
		xpos +=INCREMENT;
	else if( zoom<0 && xon )
		xpos -=INCREMENT;
//	if ( yon ) 
//		ypos +=INCREMENT;
	if (  up>0 && yon) 
		ypos +=INCREMENT;
	else if( up<0 && yon )
		ypos -=INCREMENT;

	if(abs(xpos)>my/2 ||abs(ypos)>my/2 )
	{
		zoom = -1*zoom;
	}
	if(abs(ypos)>my/2)
	{
		up = -1*up;
	}
	if(ypos>my/2)
			ypos =my/2;
	if(ypos<-my/2)
			ypos =-my/2;
	if(xpos>my/2)
			xpos =my/2;
	if(xpos<-my/2)
			xpos =-my/2;


}

//<<<<<<<<<<<<<<<<<<<<<<mouse>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myMouse(int button, int state, int x, int y)
{
        if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
        {
			stop =1;
			xon = xon == 1? 0:1;	
		}
		if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
        {
			stop =1;
			yon = yon == 1? 0:1;	
		}
		
}


//<<<<<<<<<<<<<<<<<<<<<<keyboad>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myKeyboard(unsigned char key,int x, int y)
{
      	//use keys to translte big dipper
        switch(key) 
        {	
           	
			case 'q':
					i1=(i1<9)? i1 +1:0;
                break;
			case 'w':
					i2=(i2<9)? i2 +1:0;
                break;
			case 'e':
					s1=(s1<9)? s1 +1:0;
                break;
			case 'r':
					t1=(t1<9)? t1 +1:0;
                break;

			case 'z':
					teaz=(teaz<=1)?teaz+.1:-1;
                break;
			case 'x':
					teax=(teax<=1)?teax+.1:-1;
                break;
			case 'c':
					teay=(teay<=1)?teay+.1:-1;
                break;
			case 's':
				stop = (stop ==0)? 1:0;
				break;
			case 't':
				tea = tea == 0 ?1: 0;
				break;
			case 'f':
				ne = ne == 0 ?1: 0;
				break;
			case 'i':
				if (  up>0) 
					ypos +=INCREMENT;
				else if( up<0  )
					ypos -=INCREMENT;
				yon =0;
				break;
			case 'k':
				if (  up>0) 
					ypos -=INCREMENT;
				else if( up<0  )
					ypos +=INCREMENT;
				yon =0;
				break;
			case 'j':
				if (  zoom>0) 
					xpos -=INCREMENT;
				else if( zoom<0  )
					xpos +=INCREMENT;
				xon =0;
				break;
			case 'l':
				if (  zoom>0) 
					xpos +=INCREMENT;
				else if( zoom<0  )
					xpos -=INCREMENT;
				yon =0;
				break;

			case 27:    //ESC key
                exit(1); //exit program
            default:
                break;
        }
	
}


//<<<<<<<<<<<<<<<<<<<<<myresharpe>>>>>>>>>>>>>>>>>>>>>>>
void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity(); 
    if (w <= h) 
	glOrtho (-mw, mw, -mw*(GLfloat)h/(GLfloat)w, mw*(GLfloat)h/(GLfloat)w, -1.0, 1.0);
    else 
	glOrtho (-mw*(GLfloat)w/(GLfloat)h, mw*(GLfloat)w/(GLfloat)h, -mw, mw, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity ();
}



//<<<<<<<<<<<<<<<<<<<<<myint>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myInit(void)
{
	GLfloat lightPosition0[]={0.0f,3.0f,100.0f, 0.0f};
	GLfloat lightIntensity[] = {0.7f, 0.7f, 0.7f, 1.0f};	
	glLightfv(GL_LIGHT0, GL_DIFFUSE, lightIntensity);
	glEnable(GL_LIGHTING);	
	glEnable(GL_LIGHT0);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	//texture
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 
	glClearColor(0.0,0.0,0.0,1.0);

}
	

void
main(int argc, char **argv)
{
   //GLubyte image[64][64][3];
   int i, j, c1,c2,c3,t1,t2,t3;
   for(i=0;i<64;i++)
   {
     for(j=0;j<64;j++)
     {
       c1 = ( (((i&0x8)==0)^((j&0x8)==0)) )*255;

	   c2= (((((i&0x8)==0)&&((j&0x2))==0))+1)*(255-i);
	   c3 = (((((i&0x8)==0)&&((j&0x2))==0))+1)*(255);
	   t1 =	((c1^(((i&0x7) + (j&0x7))<0x8)))*(255-j);
	   t2 =	((c1^(((i&0x7) + (j&0x7))<0x8)))*(255-i);
	   t3 =	((c1^(((i&0x7) + (j&0x7))<0x8)))*(255-(j+i));

       image0[i][j][0]= (GLubyte) c1;
       image0[i][j][1]= (GLubyte) c1;
       image0[i][j][2]= (GLubyte) c1;
	   
	   image1[i][j][0]= (GLubyte) t1;
       image1[i][j][1]= (GLubyte) t2;
       image1[i][j][2]= (GLubyte) t3;
     }
   }
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	
	glutInitWindowSize(SCREENWIDTH, SCREENHEIGHT);	
	glutInitWindowPosition(0, 0);	
	win1 = glutCreateWindow("Chris' IIST");	
	

 
	
	glutDisplayFunc(myDisplay);		//display 
	glutReshapeFunc (myReshape);	//check for window resize
	glutMouseFunc(myMouse);			//look for mouse events
	glutKeyboardFunc(myKeyboard);	//look for keyboad events

	glutIdleFunc(Idle);

	myInit();


   glutMainLoop();
}
