#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <GL/Gl.h>
#include <GL/glut.h>

#define SCREENWIDTH 1024.0
#define SCREENHEIGHT 800.0
   
int win1, win2;
const mw = SCREENHEIGHT/2;
GLuint	base;
char mytext[256]="set";

int stop =0;
GLfloat rotate=0,colour =0,rotate2 =0,teaz=0,teax=0,teay=1,rotIISTx =.3,rotIISTy =0.3,rotIISTz =1;
GLfloat rotatepot=0 ,MoveX=0,MoveY=0,track=0,zoom=1;

//<<<<<<<<<<<<maketeapot>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 
void maketeapot(GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT )
{
	//set colour for and materal properties for teapot
	GLfloat mat_ambient[]= {RedA, GreenA, BlueA, 1.0};
	GLfloat mat_diffuse[] = {RedD, GreenD, BlueD, 1.0};
	GLfloat mat_specular[] = {1.0, 0.8, 1.0, 1.0};
	GLfloat mat_shininess[] = {10.0};

	
	// set teapot colours
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
	glRotatef(rotateT ,teax,teay,teaz);
	
	glutSolidTeapot(8);

}

///<<<<<<<<<<<<<<<drawI>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and I out of tea pots
void drawI(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	
	glPushMatrix();	
	glTranslated(x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(25+x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();	//middle done
	glPushMatrix();
	glTranslated(x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //all done
		
}

///<<<<<<<<<<<<<<<drawS>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and S out of tea pots
void drawS(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	glPushMatrix();	
	glTranslated(x+5,y-10, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-10, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(x+5,y-40, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-60, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();//middle done
	glPushMatrix();
	glTranslated(x+5,y-90, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(45+x,y-90, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //all done
		
}
///<<<<<<<<<<<<<<<drawT>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//draw and T out of tea pots
void drawT(GLfloat x, GLfloat y,GLfloat RedA, GLfloat GreenA, GLfloat BlueA,
				GLfloat RedD, GLfloat GreenD, GLfloat BlueD,
				GLfloat rotateT)
{
	glPushMatrix();	
	glTranslated(x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(50+x,y, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix(); //top done
	glPushMatrix();
	glTranslated(25+x,y-25, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-50, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
	glPushMatrix();
	glTranslated(25+x,y-75, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();	//middle done
	glPushMatrix();
	glTranslated(25+x,y-100, 0);
	maketeapot(RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	glPopMatrix();
		
}
///<<<<<<<<<<<<<<<<<<<<draw char>>>>>>>>>>>>>>>>>>>>>>>>>>
void drawtext(const char *text)
{
	int i =0;
	

	base = glGenLists(256);
	
	for( i =0; i<255;i++)
	{
		glNewList(base +i,GL_COMPILE);
		//glutBitmapCharacter(GLUT_BITMAP_9_BY_15, i);
		glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, i);
		glEndList();
	}
	glListBase(base);
	glCallLists((GLint) strlen(text),GL_UNSIGNED_BYTE, text);
	
	
}

//<<<<<<<<<<<<<<<<<<<<myDisplay>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myDisplay(void)
{

	glMatrixMode(GL_PROJECTION);	
	glLoadIdentity();	
	glOrtho(-mw/2,  mw/2, -mw/2, mw/2, -200, 500.0);	
	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();	
	gluLookAt(0,0,100, 0,0.25,0, 0.0,1.0,0.0);	

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
	
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(MoveX,MoveY,0);
	glRotatef(rotatepot,teax,teay,teaz);// fun  8888888
	glPushMatrix();		
	glRotatef(rotate2 = (stop==0)?rotate2+1:rotate2, rotIISTx, rotIISTy, rotIISTz);


	drawI(-155,50,1.0,0.0,0.0,0.6,0.2,0.0,rotatepot); //drawI(-155,0,RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	drawI(-75,50 ,1.0,0.0,0.8,0.6,0.2,0.0,rotatepot);
	drawS(0,50   ,0.0,0.0,1.0,0.0,0.2,0.7,rotatepot);
	drawT(75,50  ,0.6,0.6,0.6,0.2,0.2,0.2, rotatepot);
	rotatepot=rotatepot+2;
	glPopMatrix();
	glPopMatrix();

	
	glPushMatrix();
	glColor3f(1.0,1.0,1.0);
	glTranslatef(-mw/2+5,-mw/2 +15,10); //move text
	glScalef(0.04,0.04,1); //set text scale size
	sprintf(mytext,"rotate teaz : %3.1f   rotate teax : %3.1f   rotate teay : %3.1f     zoom : %3.0f", teaz,teax,teay,zoom);
	drawtext(mytext);
	glPopMatrix();
	
	glPushMatrix();
	glColor3f(1.0,1.0,1.0);
	glTranslatef(-mw/2+5,-mw/2 +5,10);
	glScalef(0.04,0.04,1); //set text scale size
	sprintf(mytext,"Xpos : %3.0f Ypos : %3.0f        rotIISTx : %3.1f  rotIISTy : %3.1f  rotIISTz : %3.1f", MoveX,MoveY,rotIISTx,rotIISTy,rotIISTz);
	drawtext(mytext);
	glPopMatrix();

	glutPostRedisplay();//updated
	glutSwapBuffers();
}

//<<<<<<<<<<<<<<<<<<<<myDisplay2>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myDisplay2(void)
{

	glMatrixMode(GL_PROJECTION);	
	glLoadIdentity();	
	glOrtho(-mw/2,  mw/2, -mw/2, mw/2, -200, 500.0);	
	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();	
	gluLookAt(0,0,100, 0,0.25,0, 0.0,1.0,0.0);	
//
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);			
	glColor3f(0,1,0);	
	
	glPushMatrix();
	glScalef(zoom,zoom,zoom);
	glTranslatef(MoveX,MoveY,0);
	glPushMatrix();	

	glRotatef(rotate2, rotIISTx, rotIISTy, rotIISTz);

	drawI(-155,50,1.0,0.0,0.0,0.6,0.2,0.0,rotatepot); //drawI(-155,0,RedA,GreenA,BlueA,RedD,GreenD,BlueD,rotateT);
	drawI(-75,50 ,1.0,0.0,0.8,0.6,0.2,0.0,rotatepot);
	drawS(0,50   ,0.0,0.0,1.0,0.0,0.2,0.7,rotatepot);
	drawT(75,50  ,0.6,0.6,0.6,0.2,0.2,0.2, rotatepot);

	glPopMatrix();
	glPopMatrix();

	glutPostRedisplay();//updated
	glutSwapBuffers();
}
//<<<<<<<<<<<<<<<<<<<<<<mouse>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myMouse(int button, int state, int x, int y)
{
        if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
        {
			stop =1;
			zoom =zoom+1;	
		}
	
		if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
        {
			stop =1;
			zoom =zoom-1;	
		}
	

		
}


//<<<<<<<<<<<<<<<<<<<<<<keyboad>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myKeyboard(unsigned char key,int x, int y)
{
      	//use keys to translte big dipper
        switch(key)
        {	
            case 'a':
					MoveX +=-1;
					stop = 0; //STOP rotate
				break;
			case 'd':
					MoveX +=1;
					stop = 0; //STOP rotate
				break;
            case 'w':
					MoveY +=1;
					stop = 0; //STOP rotate
                break;
			case 's':
					MoveY +=-1;
					stop = 0; //STOP rotate
                break;
			case 'z':
					teaz=(teaz<=1)?teaz+.1:-1;
                break;
			case 'x':
					teax=(teax<=1)?teax+.1:-1;
                break;
			case 'c':
					teay=(teay<=1)?teay+.1:-1;
                break;
			case 'q':
				stop = (stop ==0)? 1:0;
				break;
			case 'v':
				rotIISTx=(rotIISTx<=1)?rotIISTx+.1:0;
				break;
			case 'b':
				rotIISTy=(rotIISTy<=1)?rotIISTy+.1:0;
				break;
			case 'n':
				rotIISTz=(rotIISTz<=1)?rotIISTz+.1:0;
				break;
			case 'f':
				zoom=zoom+.1;
				break;
			case 'r':
				zoom=zoom-.1;
				break;

			case 27:    //ESC key
                exit(1); //exit program
            default:
                break;
        }
	
}

//<<<<<<<<<<<<<<<<<<<<<myresharpe>>>>>>>>>>>>>>>>>>>>>>>
void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity(); 
    if (w <= h) 
	glOrtho (-mw, mw, -mw*(GLfloat)h/(GLfloat)w, mw*(GLfloat)h/(GLfloat)w, -1.0, 1.0);
    else 
	glOrtho (-mw*(GLfloat)w/(GLfloat)h, mw*(GLfloat)w/(GLfloat)h, -mw, mw, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity ();
}
//<<<<<<<<<<<<<<<<<<<<<myint>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void myInit(void)
{
	//setup lighting and depth tests
//	gluLookAt(0,0,100, 0,0.25,0, 0.0,1.0,0.0);
	GLfloat lightPosition0[]={0.0f,3.0f,100.0f, 0.0f};
//	GLfloat lightPosition1[]={2.0f,3.0f,150.0f, 0.0f};
//	GLfloat lightPosition2[]={50.0f,50.0f,0.0f, 0.0f};
	GLfloat lightIntensity[] = {0.7f, 0.7f, 0.7f, 1.0f};
	glLightfv(GL_LIGHT0, GL_DIFFUSE, lightIntensity);
	glEnable(GL_LIGHTING);	
	glEnable(GL_LIGHT0);
//	glEnable(GL_LIGHT1);
//	glEnable(GL_LIGHT2);
	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition0);
//	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition1);
//	glLightfv(GL_LIGHT2, GL_POSITION, lightPosition2);
	glShadeModel(GL_SMOOTH);	
	glEnable(GL_DEPTH_TEST);	
	glEnable(GL_NORMALIZE);	
	glClearColor(0.3f,0.3f,0.5f,0.0f); //background colour	
	glViewport(0,0, SCREENWIDTH, SCREENHEIGHT);	
}


//<<<<<<<<<<<<<<<<main>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
main( int argc, char **argv)
{
	
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
	glutInitWindowSize(SCREENWIDTH, SCREENHEIGHT);	
	glutInitWindowPosition(0, 0);	
	win1 = glutCreateWindow("Chris' IIST");	
	
	glutDisplayFunc(myDisplay);		//display 
	glutReshapeFunc (myReshape);	//check for window resize
	glutMouseFunc(myMouse);			//look for mouse events
	glutKeyboardFunc(myKeyboard);	//look for keyboad events
	myInit();

	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
	glutInitWindowSize(SCREENWIDTH/2, SCREENHEIGHT/2);	//set window size
	glutInitWindowPosition(100,0);	//set window postion
	win2 = glutCreateWindow("Chris' IIST Centre Zoom");	//open window
	glutDisplayFunc(myDisplay2);		//register redraw function
	glutMouseFunc(myMouse);			//look for mouse events
	glutKeyboardFunc(myKeyboard);	//look for keyboad events
	glutReshapeFunc (myReshape);	//check for window resize
	myInit();



	glutMainLoop();

	return 1;
}
